<template>
  <div class="user-message-button-add-on" v-if="canSendMessage">
    <router-link class="btn btn-primary" :to="route">
      <i class="bi bi-envelope-fill"></i>
      {{ buttonText }}
    </router-link>
  </div>
</template>

<script>
import { computed } from 'vue'
import { useStore } from 'vuex'

export default {
  name: 'UserMessageButtonAddOn',
  props: {
    user: { type: Object, required: true },
  },
  setup(props) {
    const store = useStore()

    const route = computed(() => {
      return props.user ? { name: 'messaging-messages-conversation', params: { username: props.user.username } } : null
    })

    const buttonText = computed(() => {
      return `Send ${props.user.username} a Message`
    })

    const canSendMessage = computed(() => {
      return store.state.identity.session.userId > 0 && store.state.identity.session.username !== props.user.username
    })

    return {
      route,
      buttonText,
      canSendMessage,
    }
  },
}
</script>
